> ## Documentation Index
> Fetch the complete documentation index at: https://platform.tatango.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Introduction

> Get started with the Tatango v2 API

Welcome to the Tatango v2 API! The Tatango v2 API is designed for developers, engineers, or anyone else who's comfortable creating custom-coded solutions or integrating with RESTful APIS. If you're not familiar with API concepts like HTTP response codes, REST endpoints, and JSON, try Zapier.

## Authentication

Tatango authenticates API requests by validating an API key that must be passed with each API call. We use the built-in HTTP basic authentication scheme supported by most HTTP libraries. Use your login email as the username and the API key as the password.

<Tabs>
  <Tab title="cURL">
    ```bash theme={null}
    curl -u "your_email@example.com:your_api_key" https://app.tatango.com/api/v2/lists
    ```
  </Tab>

  <Tab title="Ruby">
    ```ruby theme={null}
    require 'net/http'
    require 'uri'

    uri = URI.parse('https://app.tatango.com/api/v2/example-endpoint')
    http = Net::HTTP.new(uri.host, uri.port)
    request = Net:HTTP::Get.new(uri.request_url)
    request.basic_auth("emailaddress@mydomain.com", "my_api_key")
    response = http.request(request)
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
    var request = new XMLHttpRequest();
    request.open("POST", "https://app.tatango.com/api/v2/example-endpoint", false);
    request.setRequestHeader("Content-Type", "application/json");
    request.setRequestHeader("Content-Type", "application/json");
    request.setRequestHeader(
      "Authorization",
      "Basic " + btoa("emailaddress@mydomain.com:my_api_key")
    );
    request.send(null);;
    ```
  </Tab>
</Tabs>

<Warning>
  Make sure to replace my\_api\_key with your API key, which can be obtained by logging into the [Tatango App](https://app.tatango.com).
</Warning>

<Note>
  You can access your API key [here](http://help.tatango.com/api/api-keys).
</Note>

## Returning multiple results and pagination

By default, `GET` API calls that return multiple items in a list will return up to 10 items for a single call. The `pages_count` parameter in the returned JSON will indicate the number of "pages" included in the entire result set. (So for example, if a call to [https://app.tatango.com/api/v2/lists](https://app.tatango.com/api/v2/lists) finds 27 lists in the system, the JSON will include the following (see JSON snippet below):

```json theme={null}
{
  "per_page":10,
  "count":27,
  "page":1,
  "pages_count":3
}
```

<Note>
  The `pages_count` parameter will default to 0 when there is no items in the list.
</Note>

To fetch the next page of results, pass the `page` parameter on the URL, like this: [https://app.tatango.com/api/v2/lists?page=2](https://app.tatango.com/api/v2/lists?page=2). You can also change the number of records returned in each "page" by passing in a "per\_page" parameter as part of the URL, like this: [https://app.tatango.com/api/v2/lists?per\_page=50](https://app.tatango.com/api/v2/lists?per_page=50).

<Warning>
  Note that the system will only allow up to 1000 records to be returned in a single call.
</Warning>

## Carrier IDs

This section provides a list of carrier ID and names (US and Canada) for any response that includes `carrier` and `carrierName`.

### United States Carriers

| Carrier Name                                 | Carrier ID |
| -------------------------------------------- | ---------- |
| 1st Point (a.k.a. Shelcomm)                  | 11293      |
| Aerialink                                    | 11333      |
| Alaska Communications Systems (ACS)          | 592        |
| Altice Mobile                                | 11359      |
| ASTAC                                        | 10242      |
| AT\&T                                        | 383        |
| Atlantic Tele-Network International (ATNI)   | 10542      |
| bandwidth.com (includes Republic Wireless)   | 766        |
| Bluegrass Cellular                           | 562        |
| Boost                                        | 628        |
| Brightlink                                   | 10212      |
| Bristol Bay Telephone Cooperative            | 11332      |
| C Spire Wireless (aka Cellular South)        | 386        |
| Carolina West Wireless                       | 564        |
| Cellcom                                      | 587        |
| Cellular One of N.E. Arizona                 | 566        |
| Chariton Valley Cellular                     | 701        |
| Chat Mobility                                | 619        |
| Copper Valley Telecom                        | 802        |
| Cordova                                      | 10282      |
| Cross Wireless                               | 618        |
| Digital Communications Consulting            | 11316      |
| DISH Wireless                                | 12227      |
| Duet Wireless                                | 696        |
| East Kentucky Network (Appalachian Wireless) | 570        |
| Enflick                                      | 10262      |
| GCI Communications                           | 603        |
| Google Voice                                 | 798        |
| Illinois Valley Cellular                     | 574        |
| Indigo Wireless                              | 11174      |
| Inland Cellular                              | 575        |
| Inteliquent                                  | 10232      |
| ISP Telecom                                  | 12228      |
| James Valley Cellular (JVC)                  | 11304      |
| MetroPCS                                     | 788        |
| MTPCS Cellular One (Cellone Nation)          | 655        |
| Nemont CDMA                                  | 796        |
| Nemont UMTS                                  | 873        |
| Nex Tech Communications                      | 578        |
| Northwest Missouri Cellular                  | 620        |
| Panhandle Wireless                           | 626        |
| Pine Belt                                    | 10352      |
| Pine Cellular                                | 580        |
| Pioneer Cellular                             | 621        |
| Plivo                                        | 11620      |
| Ring Central                                 | 11638      |
| Rural Independent Network Alliance (RINA)    | 567        |
| SouthernLINC                                 | 763        |
| Sprint                                       | 34         |
| Standing Rock Telecom                        | 764        |
| T-Mobile                                     | 79         |
| Telnyx                                       | 11351      |
| TextMe                                       | 11306      |
| Thumb Cellular                               | 604        |
| Tracfone                                     | 556        |
| Triangle Wireless                            | 10272      |
| Truphone                                     | 11318      |
| TSG Global (Flex Talk)                       | 11671      |
| Tychron                                      | 12227      |
| Union Telephone                              | 549        |
| United States Cellular Corp                  | 56         |
| United Wireless                              | 602        |
| Verizon                                      | 77         |
| Viaero Wireless                              | 650        |
| Virgin Mobile                                | 525        |
| West Central Wireless                        | 559        |
| Zipwhip                                      | 11749      |

### Canadian Carriers

| Carrier Name      | Carrier ID |
| ----------------- | ---------- |
| Aliant            | 509        |
| Bell Mobility     | 80         |
| Eastlink Wireless | 799        |
| Execulink         | 10573      |
| Fido (Microcell)  | 138        |
| Fizz              | 10638      |
| Freedom / Wind    | 653        |
| Mobilicity        | 654        |
| MTS               | 510        |
| NorthernTel       | 512        |
| Rogers            | 75         |
| Sasktel           | 102        |
| SSI Micro         | 11315      |
| Telebec           | 511        |
| Telus             | 70         |
| Videotron         | 615        |
| Virgin Mobile     | 537        |

## Errors

The Tatango v2 API uses the following error codes:

| Error Code | Meaning                                                                                                                                                                                            |
| ---------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 400        | Bad Request -- Your request is invalid.                                                                                                                                                            |
| 401        | Unauthorized -- Your API key is wrong.                                                                                                                                                             |
| 403        | Forbidden -- You are not authorized for this request.                                                                                                                                              |
| 404        | Not Found -- The specified endpoint could not be found.                                                                                                                                            |
| 405        | Method Not Allowed -- You tried to access an endpoint with an invalid method.                                                                                                                      |
| 406        | Not Acceptable -- You requested a format that isn't JSON.                                                                                                                                          |
| 410        | Gone -- The requested resource has been removed from our servers.                                                                                                                                  |
| 422        | Unprocessable Entity - There was a problem of some sort with either the JSON or request parameters you supplied. Usually, this error will be accompanied by a detailed description of the problem. |
| 429        | Too Many Requests -- You're requesting too many resources! Slow down!                                                                                                                              |
| 500        | Internal Server Error -- We had a problem with our server. Try again later.                                                                                                                        |
| 502        | Bad Gateway -- We had a problem with our server. Try again later.                                                                                                                                  |
| 503        | Service Unavailable -- We're temporarily offline for maintenance. Please try again later.                                                                                                          |
